ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.9 by root, Sun Mar 11 22:36:53 2007 UTC vs.
Revision 1.66 by root, Thu Dec 27 15:43:11 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
19use YAML::Syck ();
20use JSON::XS ();
18use IO::AIO (); 21use IO::AIO ();
19use File::Temp; 22use File::Temp;
20use Crossfire; 23use Deliantra;
21use Coro; 24use Coro;
22use Coro::AIO; 25use Coro::AIO;
26use Coro::Util;
23use POSIX (); 27use POSIX ();
24use Digest::MD5; 28use Carp;
29use Coro::Channel;
30use Coro::Storable; $Storable::canonical = 1;
31
32$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 33
26sub usage { 34sub usage {
27 warn <<EOF; 35 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 36Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 37 [--install-arch path]
41my $CACHE = 0; 49my $CACHE = 0;
42my $FORCE; 50my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 51my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 52my $TMPFILE = "aaaa0";
45 53
54our %COLOR = (
55 black => 0,
56 white => 1,
57 navy => 2,
58 red => 3,
59 orange => 4,
60 blue => 5,
61 darkorange => 6,
62 green => 7,
63 lightgreen => 8,
64 grey => 9,
65 brown => 10,
66 gold => 11,
67 tan => 12,
68);
69
46END { system "rm", "-rf", $TMPDIR } 70END { system "rm", "-rf", $TMPDIR }
47 71
48Event->signal (signal => "INT", cb => sub { exit 1 }); 72Event->signal (signal => "INT", cb => sub { exit 1 });
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 73Event->signal (signal => "TERM", cb => sub { exit 1 });
50 74
67} 91}
68 92
69sub inst_maps($) { 93sub inst_maps($) {
70 my (undef, $path) = @_; 94 my (undef, $path) = @_;
71 95
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 96 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 97
74 if (!-f "$path/regions") { 98 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 99 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 100 exit 1 unless $FORCE;
77 } 101 }
78 102
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 103 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
104 "$path/.", "$DATADIR/maps/.",
105 "--exclude", "CVS", "--exclude", "/world-precomposed",
106 "--delete", "--delete-excluded"
107 and die "map installation failed.\n";
108
109 print "maps installed successfully.\n";
80} 110}
81 111
82{ 112{
83 our %PNG32; 113 our %ANIMINFO;
84 our %FACEINFO; 114 our %FACEINFO;
115 our %RESOURCE;
85 our @ARC; 116 our @ARC;
117 our %ARC;
118 our $TRS;
86 our $NFILE; 119 our $NFILE;
87 our %ANIM; 120 our $PATH;
88 121
89 our (@png, @trs, @arc); # files we are interested in 122 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 123
124 our $c_arc = new Coro::Channel;
125 our $c_trs = new Coro::Channel;
126 our $c_res = new Coro::Channel;
127
128 our @c_png;
129
91 sub commit_png { 130 sub commit_png($$$) {
92 my ($name, $data) = @_; 131 my ($name, $data, $T) = @_;
93 132
94 $PNG32{$name} = $data; 133 $FACEINFO{$name}{"data$T"} = $data;
95 $FACEINFO{$name} ||= {};
96 } 134 }
97 135
98 sub process_png { 136 sub process_png {
99 while (@png) { 137 while (@c_png) {
100 my $path = pop @png; 138 my ($path, $delete) = @{pop @c_png};
101 139
102 my $png; 140 my $png;
103 aio_lstat $path; 141 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 142 my ($size, $mtime) = (stat _)[7,9];
105 143
106 if (0 > aio_load $path, $png) { 144 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 145 warn "$path: $!, skipping.\n";
108 next; 146 next;
109 } 147 }
110 148
149 my $stem = $path;
150 my $T;
151
152 if ($stem =~ s/\.32x32\.png~?$//) {
153 $T = 32;
154 } elsif ($stem =~ s/\.64x64\.png~?$//) {
155 $T = 64;
156 } else {
157 warn "$path: weird filename, skipping.\n";
158 next;
159 }
160
111 # quickly extract width and height of the (necessarily PNG) image 161 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 162 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 163 warn "$path: not a recognized png file, skipping.\n";
114 next; 164 next;
115 } 165 }
116 166
117 my ($w, $h) = unpack "NN", $1; 167 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 168
127 if ($w < $T || $h < $T) { 169 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 170 warn "$path: too small ($w $h), skipping.\n";
129 next; 171 next;
130 } 172 }
132 if ($w % $T || $h % $T) { 174 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 175 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 176 next;
135 } 177 }
136 178
179 (my $base = $stem) =~ s/^.*\///;
180
181 my $fi = $FACEINFO{$base};
182 unless ($fi) {
183 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
184 #next;
185 }
186
187 my $arc = $fi->{arc} || { };
188
189 unless ($path =~ /~$/) {
190 # possibly enlarge
191 if (0 > aio_stat "$stem.64x64.png") {
192 my $other = "$stem.64x64.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 my $CROP;
197 my $SRC = "png:\Q$path\E";
198
199 my $is_floor = $arc->{is_floor};
200 my $is_wall = 0;
201
202 my ($wall_pfx, $wall_dir, $wall_sfx);
203
204 if (
205 !$is_floor
206 && !$arc->{alive}
207 && $arc->{move_block} eq "all"
208 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
209 ) {
210 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
211
212 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
213 $is_wall = 1;
214 }
215 }
216
217 if ($is_wall || $is_floor) {
218 # add a 4px border and add other images around it
219 $CROP = "-shave 8x8 +repage";
220
221 $w += 8;
222 $h += 8;
223
224 $SRC = "-size ${w}x${h} xc:transparent";
225 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
226
227 # 8 surrounding images
228 for (
229 # x y b r0 r1
230 [-1, -1, 0, 6],
231 [ 0, -1, 1, 10, 14],
232 [+1, -1, 0, 12],
233
234 [-1, 0, 8, 5, 7],
235 #
236 [+1, 0, 2, 5, 13],
237
238 [-1, +1, 0, 3],
239 [ 0, +1, 4, 10, 11],
240 [+1, +1, 0, 9],
241 ) {
242 my ($x, $y, $d, $r0, $r1) = @$_;
243
244 my $tile = $is_floor ? $path
245 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
246 : die;
247
248 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
249 "\Q$tile",
250 $x * ($w - 8) + 4,
251 $y * ($h - 8) + 4;
252 }
253 }
254
255 system "convert -depth 8 $SRC rgba:-"
256 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
257 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
258 and die "convert/cfhq2xa pipeline error: status $? ($!)";
259 system $OPTIPNG, "-i0", "-q", "$other~";
260 die "$other~ has zero size, aborting." unless -s "$other~";
261 rename "$other~", $other;
262 };
263 }
264
265 push @c_png, [$other, !$CACHE];
266 }
267
268 # possibly scale down
269 if (0 > aio_stat "$stem.32x32.png") {
270 my $other = "$stem.32x32.png~";
271
272 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
273 fork_sub {
274 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
275 system $OPTIPNG, "-i0", "-q", "$other~";
276
277 # reduce smoothfaces >10000 bytes
278 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
279 my $ncolor = 256;
280 while () {
281 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
282 system $OPTIPNG, "-i0", "-q", "$other~~";
283 last if 10000 > -s "$other~~";
284 $ncolor = int $ncolor * 0.9;
285 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
286 }
287
288 printf "reduced %s from %d to %d bytes using %d colours.\n",
289 $other, -s "$other~", -s "$other~~", $ncolor
290 if $VERBOSE >= 2;
291 rename "$other~~", "$other~";
292 }
293
294 die "$other~ has zero size, aborting." unless -s "$other~";
295 rename "$other~", $other;
296 };
297 }
298
299 #warn "scaled down $path to $other\n";#d#
300 push @c_png, [$other, !$CACHE];
301 }
302 }
303
304 (my $face = $stem) =~ s/^.*\///;
305
306 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 307 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 308 # split
139 my @tile; 309 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 310 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 311 for my $y (0 .. (int $h / $T) - 1) {
155 ( 325 (
156 "(", 326 "(",
157 "+clone", 327 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 328 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
159 "+repage", 329 "+repage",
330 -quality => "00",
160 -write => "png:$_->[2]~", 331 -write => "png32:$_->[2]~",
161 "+delete", 332 "+delete",
162 ")", 333 ")",
163 ) 334 )
164 } @todo), 335 } @todo),
165 "null:"; 336 "null:";
169 close $convert; 340 close $convert;
170 341
171 # pass 2, optimise, and rename 342 # pass 2, optimise, and rename
172 for (@todo) { 343 for (@todo) {
173 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 344 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
345 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
174 rename "$_->[2]~", $_->[2]; 346 rename "$_->[2]~", $_->[2];
175 } 347 }
176 }; 348 };
177 } 349 }
178 350
182 354
183 if (0 > aio_load $file, $tile) { 355 if (0 > aio_load $file, $tile) {
184 die "$path: unable to read tile +$x+$y, aborting.\n"; 356 die "$path: unable to read tile +$x+$y, aborting.\n";
185 } 357 }
186 IO::AIO::aio_unlink $file unless $CACHE; 358 IO::AIO::aio_unlink $file unless $CACHE;
187 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 359 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
188 } 360 }
189 } else { 361 } else {
190 # use as-is (either small, use smooth) 362 # use as-is (either small, use smooth)
191 commit_png $face, $png; 363 commit_png $face, $png, $T;
192 } 364 }
365
366 aio_unlink $path if $delete;
193 } 367 }
194 } 368 }
195 369
196 sub process_arc { 370 sub process_arc {
197 while (@arc) { 371 while (my $job = $c_arc->get) {
198 my ($dir, $file) = @{pop @arc}; 372 my ($dir, $file) = @$job;
199 373
200 my $arc; 374 my $arc;
201 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 375 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
202 376
203 my $arc = read_arch "$dir/$file"; 377 my $arc = read_arch "$dir/$file";
204 for my $o (values %$arc) { 378 for my $o (values %$arc) {
205 push @ARC, $o; 379 push @ARC, $o;
380 for (my $m = $o; $m; $m = $m->{more}) {
381 $ARC{$m->{_name}} = $m;
382 }
383
384 $o->{editor_folder} = $dir;
206 385
207 my $visibility = delete $o->{visibility}; 386 my $visibility = delete $o->{visibility};
208 my $magicmap = delete $o->{magicmap}; 387 my $magicmap = delete $o->{magicmap};
209 388
210 # find upper left corner :/ 389 # find upper left corner :/
219 my $x = $o->{x} - $dx; 398 my $x = $o->{x} - $dx;
220 my $y = $o->{y} - $dy; 399 my $y = $o->{y} - $dy;
221 400
222 my $ext = $x|$y ? "+$x+$y" : ""; 401 my $ext = $x|$y ? "+$x+$y" : "";
223 402
224 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 403 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
225 404
226 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 405 $visibility = delete $o->{visibility} if exists $o->{visibility};
227 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 406 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
228 407
229 my $anim = delete $o->{anim}; 408 my $anim = delete $o->{anim};
230 409
231 if ($anim) { 410 if ($anim) {
411 # possibly add $ext to the animation name to avoid
412 # the need to specify archnames for all parts
413 # of a multipart archetype.
232 $o->{animation} = "$o->{_name}"; 414 $o->{animation} = "$o->{_name}";
415 my $facings = 1;
416 my @frames;
233 417
234 for (@$anim) { 418 for (@$anim) {
235 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 419 if (/^facings\s+(\d+)/) {
420 $facings = $1*1;
421 } elsif (/^blank.x11$|^empty.x11$/) {
422 push @frames, $_;
423 } else {
424 push @frames, "$_$ext";
425 }
236 } 426 }
237 427
238 $ANIM{"$o->{_name}$ext"} = 428 $ANIMINFO{$o->{animation}} = {
239 join "", map "$_\n", 429 facings => $facings,
240 "anim $o->{_name}", 430 frames => \@frames,
241 @$anim,
242 "mina";
243 } 431 };
432 }
244 433
245 for my $face ($o->{face} || (), @{$anim || []}) { 434 for ($o->{face} || (), @{$anim || []}) {
246 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 435 next if /^facings\s/;
247 436
437 my $face = $_;
438 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
439
248 my $info = $FACEINFO{$face} ||= {}; 440 my $info = $FACEINFO{$face} ||= { };
441 $info->{arc} = $o;
442
443 next if $face =~ /^blank.x11$|^empty.x11$/;
249 444
250 $info->{visibility} = $visibility if defined $visibility; 445 $info->{visibility} = $visibility if defined $visibility;
251 $info->{magicmap} = $magicmap if defined $magicmap; 446 $info->{magicmap} = $magicmap if defined $magicmap;
252 } 447 }
448
449 if (my $smooth = delete $o->{smoothface}) {
450 my %kv = split /\s+/, $smooth;
451 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
452 while (my ($face, $smooth) = each %kv) {
453 $FACEINFO{$smooth}{arc} = $o;
454
455 $FACEINFO{$face}{smooth} = $smooth;
456 $FACEINFO{$face}{smoothlevel} = $level;
457 }
458 }
253 } 459 }
254 } 460 }
255 } 461 }
256 } 462 }
257 463
258 sub process_trs { 464 sub process_trs {
259 while (@trs) { 465 while (my $job = $c_trs->get) {
260 my ($dir, $file) = @{pop @trs}; 466 my ($dir, $file) = @$job;
467 my $path = "$dir/$file";
468
469 my $trs;
470 if (0 > aio_load $path, $trs) {
471 warn "$path: $!, skipping.\n";
472 next;
473 }
474
475 $TRS .= $trs;
476 }
477 }
478
479 my %FILECACHE;
480
481 sub load_cached($;$) {
482 unless (exists $FILECACHE{$_[0]}) {
483 my $data;
484 if (0 < aio_load $_[0], $data) {
485 if ($_[1]) {
486 $data = eval { $_[1]->($data) };
487 warn "$_[0]: $@" if $@;
488 }
489 }
490
491 $FILECACHE{$_[0]} = $data;
492 }
493
494 $FILECACHE{$_[0]}
495 }
496
497 sub process_res {
498 while (my $job = $c_res->get) {
499 my ($dir, $file, $type) = @$job;
500
501 my $data;
502 aio_load "$dir/$file", $data;
503
504 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
505
506 utf8::decode $dir;
507 utf8::decode $file;
508
509 # a meta file for resources is now mandatory
510 unless (exists $meta->{$file}) {
511 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
512 next;
513 }
514
515 $meta = {
516 %{ $meta->{"" } || {} },
517 %{ $meta->{$file} || {} },
518 };
519
520 if ($meta->{license} =~ s/^#//) {
521 $meta->{license} = ({
522 "pd" => "Public Domain",
523 "gpl" => "GNU General Public License, version 3.0 or any later",
524 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
525 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
526 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
527 })->{$meta->{license}}
528 || warn "$dir/$file: license tag '$meta->{license}' not found.";
529 }
530
531 $file =~ s/\.res$//;
532 $file =~ s/\.(ogg|wav|jpg|png)$//;
533
534 substr $dir, 0, 1 + length $PATH, "";
535
536 if (my $filter = $meta->{cfutil_filter}) {
537 if ($filter eq "yaml2json") {
538 $data = JSON::XS::encode_json YAML::Syck::Load $data;
539 } elsif ($filter eq "json2json") {
540 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
541 } elsif ($filter eq "perl2json") {
542 $data = eval $data; die if $@;
543 $data = JSON::XS::encode_json $data;
544 } else {
545 warn "$dir/$file: unknown filter $filter, skipping\n";
546 }
547 }
548
549 $RESOURCE{"$dir/$file"} = {
550 type => (exists $meta->{type} ? delete $meta->{type} : $type),
551 data => $data,
552 %$meta ? (meta => $meta) : (),
553 };
261 } 554 }
262 } 555 }
263 556
264 sub find_files; 557 sub find_files;
265 sub find_files { 558 sub find_files {
270 my ($dirs, $nondirs) = @_; 563 my ($dirs, $nondirs) = @_;
271 564
272 find_files "$path/$_" 565 find_files "$path/$_"
273 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 566 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
274 567
568 my $dir = $path;
569 substr $dir, 0, 1 + length $PATH, "";
570
275 for my $file (@$nondirs) { 571 for my $file (@$nondirs) {
572 if ($dir =~ /^music(?:\/|$)/) {
573 $c_res->put ([$path, $file, 3]) # FT_MUSIC
574 if $file =~ /\.(ogg)$/;
575
576 } elsif ($dir =~ /^sound(?:\/|$)/) {
577 $c_res->put ([$path, $file, 5]) # FT_SOUND
578 if $file =~ /\.(wav|ogg)$/;
579
580 } elsif ($dir =~ /^res(?:\/|$)/) {
581 if ($file =~ /\.(jpg|png)$/) {
582 $c_res->put ([$path, $file, 0]) # FT_FACE
583 } elsif ($file =~ /\.(res)$/) {
584 $c_res->put ([$path, $file, 7]) # FT_RSRC
585 } else {
586 $c_res->put ([$path, $file, undef]);
587 }
588
276 if ($file =~ /\.png$/) { 589 } elsif ($file =~ /\.png$/) {
277 push @png, "$path/$file"; 590 push @c_png, ["$path/$file", 0];
591
278 } elsif ($file =~ /\.trs$/) { 592 } elsif ($file =~ /\.trs$/) {
279 push @trs, [$path, $file]; 593 $c_trs->put ([$path, $file]);
594
280 } elsif ($file =~ /\.arc$/) { 595 } elsif ($file =~ /\.arc$/) {
281 push @arc, [$path, $file]; 596 $c_arc->put ([$path, $file]);
597
282 } else { 598 } else {
283 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 599 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
284 } 600 }
285 } 601 }
286 }; 602 };
287 } 603 }
288 604
289 sub inst_arch($) { 605 sub inst_arch($) {
290 my (undef, $path) = @_; 606 my (undef, $path) = @_;
291 607
608 $PATH = $path;
609
610 print "\n",
292 print "installing '$path' to '$DATADIR'\n\n"; 611 "Installing '$path' to '$DATADIR'\n",
612 "\n",
613 "This can take a long time if you run this\n",
614 "for the first time or do not use --cache.\n",
615 "\n",
616 "Unless you run verbosely, all following warning\n",
617 "or error messages indicate serious problems.\n",
618 "\n";
293 619
294 if (!-d "$path/treasures") { 620 if (!-d "$path/treasures") {
295 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 621 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
296 exit 1 unless $FORCE; 622 exit 1 unless $FORCE;
297 } 623 }
298 624
625 print "scanning files...\n" if $VERBOSE;
626
299 find_files $path; 627 find_files $path;
628
629 my @a_arc = map +(async \&process_arc), 1..2;
630 my @a_res = map +(async \&process_res), 1..2;
631 my @a_trs = map +(async \&process_trs), 1..2;
632
300 IO::AIO::flush; 633 IO::AIO::flush;
301 634
302 $_->join for ( 635 $c_res->put (undef) for @a_res;
303 (async \&process_png), (async \&process_png), 636 $c_arc->put (undef) for @a_arc;
304 (async \&process_trs), (async \&process_trs), 637 $c_trs->put (undef) for @a_trs;
305 (async \&process_arc), (async \&process_arc),
306 );
307 638
639 print "start file scan, arc, res processing...\n" if $VERBOSE;
640
641 $_->join for @a_arc; # need to parse all archetypes before png processing
642
643 print "end arc, start png processing...\n" if $VERBOSE;
644
645 # four png crunchers work fine for my 2x smp machine
646 my @a_png = map +(async \&process_png), 1..4;
647
648 $_->join for (@a_trs, @a_res, @a_png);
649
650 print "scanning done, processing results...\n" if $VERBOSE;
308 { 651 {
309 open my $fh, ">:utf8", "$DATADIR/animations~" 652 # remove path prefix from editor_folder
310 or die "$DATADIR/animations~: $!"; 653 substr $_->{editor_folder}, 0, 1 + length $path, ""
311 print $fh join "", map $ANIM{$_}, sort keys %ANIM 654 for values %ARC;
655
656 print "resolving inheritance tree...\n" if $VERBOSE;
657 # resolve inherit
658 while () {
659 my $progress;
660 my $loop;
661
662 for my $o (values %ARC) {
663 if (my $other = $o->{inherit}) {
664 if (my $s = $ARC{$other}) {
665 if ($s->{inherit}) {
666 $loop = $s;
667 } else {
668 delete $o->{inherit};
669 my %s = %$s;
670 delete @s{qw(_name more name name_pl)};
671 %$o = ( %s, %$o );
672 ++$progress;
673 }
674 } else {
675 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
676 delete $ARC{$o->{_name}};
677 }
678 }
679 }
680
681 unless ($progress) {
682 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
683 if $loop;
684
685 last;
686 }
312 } 687 }
313 688
314 { 689 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
690 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
691
692 print "writing archetypes...\n" if $VERBOSE;
315 open my $fh, ">:utf8", "$DATADIR/archetypes~" 693 open my $fh, ">:utf8", "$DATADIR/archetypes~"
316 or die "$DATADIR/archetypes~: $!"; 694 or die "$DATADIR/archetypes~: $!";
317 print $fh Crossfire::archlist_to_string \@ARC; 695 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
318 } 696 }
319 697
320 { 698 {
699 print "writing treasures...\n" if $VERBOSE;
700 open my $fh, ">:utf8", "$DATADIR/treasures~"
701 or die "$DATADIR/treasures~: $!";
702 print $fh $TRS;
703 }
704
705 {
706 print "processing facedata...\n" if $VERBOSE;
321 while (my ($k, $v) = each %FACEINFO) { 707 while (my ($k, $v) = each %FACEINFO) {
322 $v->{data32} ||= delete $PNG32{$k}; 708 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
709 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
710
711 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
712 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
713
714 if (my $magicmap = $v->{magicmap}) {
715 $magicmap =~ y/A-Z_\-/a-z/d;
716 $v->{magicmap} = $COLOR{$magicmap};
323 } 717 }
324 718
325 while (my ($k, $v) = each %FACEINFO) { 719 delete $v->{arc};
326 length $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
327
328 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
329 } 720 }
330 721
722 print "writing facedata...\n" if $VERBOSE;
331 open my $fh, ">:perlio", "$DATADIR/faces~" 723 open my $fh, ">:perlio", "$DATADIR/facedata~"
332 or die "$DATADIR/faces~: $!"; 724 or die "$DATADIR/facedata~: $!";
333 725
334 print $fh Storable::nfreeze \%FACEINFO; 726 print $fh freeze {
335 727 version => 2,
336 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 728 faceinfo => \%FACEINFO,
729 animinfo => \%ANIMINFO,
730 resource => \%RESOURCE,
337 } 731 };
732 }
338 733
734 print "committing files...\n" if $VERBOSE;
735
339 for (qw(archetypes faces animations)) { 736 for (qw(archetypes facedata treasures)) {
340 chmod 0644, "$DATADIR/$_~"; 737 chmod 0644, "$DATADIR/$_~";
341 rename "$DATADIR/$_~", "$DATADIR/$_"; 738 rename "$DATADIR/$_~", "$DATADIR/$_"
739 or die "$DATADIR/$_: $!";
342 } 740 }
343 741
344 die "--install-arch not fully implemented\n"; 742 print "archetype data installed successfully.\n";
345 } 743 }
346} 744}
347 745
348Getopt::Long::Configure ("bundling", "no_ignore_case"); 746Getopt::Long::Configure ("bundling", "no_ignore_case");
349GetOptions ( 747GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines